SystemOrganization addCategory: #MetaProgramacion!

Object subclass: #Interceptor
	instanceVariableNames: 'clases'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MetaProgramacion'!

!Interceptor commentStamp: '<historical>' prior: 0!
An Interceptor is xxxxxxxxx.

Instance Variables
!

!Interceptor methodsFor: 'as yet unclassified' stamp: 'Aureh 5/1/2013 10:22'!
agregarAlPrincipioDeLosAccesorsDeLaClase: unaClase elBloque: unBloque	
	(self dameLosAccesorsDeLaClase: unaClase) do: [:metodo | unaClase compile: (self agregarAlPrincipioDelMetodo: metodo elBloque: unBloque)].! !

!Interceptor methodsFor: 'as yet unclassified' stamp: 'Aureh 5/1/2013 10:33'!
agregarAlPrincipioDeLosMetodosDeLaClase: unaClase QueEmpiezanCon: unNombre elBloque: unBloque	
	(self dameLosMetodosDeLaClase: unaClase QueEmpiezanCon: unNombre) do: [:metodo | unaClase compile: (self agregarAlPrincipioDelMetodo: metodo elBloque: unBloque)].! !

!Interceptor methodsFor: 'as yet unclassified' stamp: 'Aureh 5/1/2013 10:17'!
agregarAlPrincipioDelMetodo: unMetodo elBloque: unBloque
	| codigo c codigoConBloque|
	c := Set new.
	codigo := unMetodo getSource.
	c := codigo findTokens: String cr, String lf.
	codigoConBloque := (((c at: 1) , '\') withCRs) , (('	', unBloque , '.' , '\') withCRs), (c last).
	^codigoConBloque.! !

!Interceptor methodsFor: 'as yet unclassified' stamp: 'Aureh 5/1/2013 20:45'!
elMetodo: unMetodo esAccesorDeLaClase: unaClase
	| c |
	c := Set new.
	c := unaClase instVarNames.
	^c anySatisfy: [:instVar | unMetodo usesInstVarNamed: instVar].! !

!Interceptor methodsFor: 'as yet unclassified' stamp: 'Aureh 5/1/2013 20:49'!
obtenerLasClasesDeLaCategoria: unaCategoria
	clases := Set new.
	clases := ((SystemOrganization listAtCategoryNamed: unaCategoria) 
				collect: [:each | Smalltalk globals at: each])
				select: [:clase | (clase isKindOf: Trait) not].
	^clases.! !

!Interceptor methodsFor: 'as yet unclassified' stamp: 'Aureh 5/1/2013 20:49'!
obtenerLosAccesorsDeLaClase: unaClase
 	| c |
	c := Set new.
	c := unaClase methods.
	^c select: [:metodo | self elMetodo: metodo esAccesorDeLaClase: unaClase].! !

!Interceptor methodsFor: 'as yet unclassified' stamp: 'Aureh 5/1/2013 20:50'!
obtenerLosMetodosDeLaClase: unaClase QueEmpiezanCon: unNombre
 	^unaClase methods select: [:unMetodo | unMetodo selector asString beginsWith: unNombre].! !
